# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class CatalogIdMapping(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, client_object_id=None, object_id=None):
        """
        CatalogIdMapping - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'client_object_id': 'str',
            'object_id': 'str'
        }

        self.attribute_map = {
            'client_object_id': 'client_object_id',
            'object_id': 'object_id'
        }

        self._client_object_id = client_object_id
        self._object_id = object_id

    @property
    def client_object_id(self):
        """
        Gets the client_object_id of this CatalogIdMapping.
        The client-supplied, temporary `#`-prefixed ID for a new [CatalogObject](#type-catalogobject).

        :return: The client_object_id of this CatalogIdMapping.
        :rtype: str
        """
        return self._client_object_id

    @client_object_id.setter
    def client_object_id(self, client_object_id):
        """
        Sets the client_object_id of this CatalogIdMapping.
        The client-supplied, temporary `#`-prefixed ID for a new [CatalogObject](#type-catalogobject).

        :param client_object_id: The client_object_id of this CatalogIdMapping.
        :type: str
        """

        self._client_object_id = client_object_id

    @property
    def object_id(self):
        """
        Gets the object_id of this CatalogIdMapping.
        The permanent ID for the [CatalogObject](#type-catalogobject) created by the server.

        :return: The object_id of this CatalogIdMapping.
        :rtype: str
        """
        return self._object_id

    @object_id.setter
    def object_id(self, object_id):
        """
        Sets the object_id of this CatalogIdMapping.
        The permanent ID for the [CatalogObject](#type-catalogobject) created by the server.

        :param object_id: The object_id of this CatalogIdMapping.
        :type: str
        """

        self._object_id = object_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
