# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class CreateOrderRequestTax(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, catalog_object_id=None, name=None, type=None, percentage=None):
        """
        CreateOrderRequestTax - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'catalog_object_id': 'str',
            'name': 'str',
            'type': 'str',
            'percentage': 'str'
        }

        self.attribute_map = {
            'catalog_object_id': 'catalog_object_id',
            'name': 'name',
            'type': 'type',
            'percentage': 'percentage'
        }

        self._catalog_object_id = catalog_object_id
        self._name = name
        self._type = type
        self._percentage = percentage

    @property
    def catalog_object_id(self):
        """
        Gets the catalog_object_id of this CreateOrderRequestTax.
        Only used for catalog taxes. The catalog object ID of an existing [CatalogTax](#type-catalogtax).  Do not provide a value for this field if you provide values in other fields for an ad hoc tax.

        :return: The catalog_object_id of this CreateOrderRequestTax.
        :rtype: str
        """
        return self._catalog_object_id

    @catalog_object_id.setter
    def catalog_object_id(self, catalog_object_id):
        """
        Sets the catalog_object_id of this CreateOrderRequestTax.
        Only used for catalog taxes. The catalog object ID of an existing [CatalogTax](#type-catalogtax).  Do not provide a value for this field if you provide values in other fields for an ad hoc tax.

        :param catalog_object_id: The catalog_object_id of this CreateOrderRequestTax.
        :type: str
        """

        if catalog_object_id is None:
            raise ValueError("Invalid value for `catalog_object_id`, must not be `None`")
        if len(catalog_object_id) > 192:
            raise ValueError("Invalid value for `catalog_object_id`, length must be less than `192`")

        self._catalog_object_id = catalog_object_id

    @property
    def name(self):
        """
        Gets the name of this CreateOrderRequestTax.
        Only used for ad hoc taxes. The tax's name.  Do not provide a value for this field if you set `catalog_object_id`.

        :return: The name of this CreateOrderRequestTax.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CreateOrderRequestTax.
        Only used for ad hoc taxes. The tax's name.  Do not provide a value for this field if you set `catalog_object_id`.

        :param name: The name of this CreateOrderRequestTax.
        :type: str
        """

        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")
        if len(name) > 255:
            raise ValueError("Invalid value for `name`, length must be less than `255`")

        self._name = name

    @property
    def type(self):
        """
        Gets the type of this CreateOrderRequestTax.
        Only used for ad hoc taxes. Indicates the calculation method used to apply the line item tax.  Default: `ADDITIVE`; See [OrderLineItemTaxType](#type-orderlineitemtaxtype) for possible values.

        :return: The type of this CreateOrderRequestTax.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this CreateOrderRequestTax.
        Only used for ad hoc taxes. Indicates the calculation method used to apply the line item tax.  Default: `ADDITIVE`; See [OrderLineItemTaxType](#type-orderlineitemtaxtype) for possible values.

        :param type: The type of this CreateOrderRequestTax.
        :type: str
        """

        self._type = type

    @property
    def percentage(self):
        """
        Gets the percentage of this CreateOrderRequestTax.
        Only used for ad hoc taxes. The percentage of the tax, as a string representation of a decimal number.  A value of `7.25` corresponds to a percentage of 7.25%. This value range between 0.0 up to 100.0

        :return: The percentage of this CreateOrderRequestTax.
        :rtype: str
        """
        return self._percentage

    @percentage.setter
    def percentage(self, percentage):
        """
        Sets the percentage of this CreateOrderRequestTax.
        Only used for ad hoc taxes. The percentage of the tax, as a string representation of a decimal number.  A value of `7.25` corresponds to a percentage of 7.25%. This value range between 0.0 up to 100.0

        :param percentage: The percentage of this CreateOrderRequestTax.
        :type: str
        """

        if percentage is None:
            raise ValueError("Invalid value for `percentage`, must not be `None`")
        if len(percentage) > 10:
            raise ValueError("Invalid value for `percentage`, length must be less than `10`")

        self._percentage = percentage

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
