# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class ObtainTokenRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, client_id=None, client_secret=None, code=None, redirect_uri=None):
        """
        ObtainTokenRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'client_id': 'str',
            'client_secret': 'str',
            'code': 'str',
            'redirect_uri': 'str'
        }

        self.attribute_map = {
            'client_id': 'client_id',
            'client_secret': 'client_secret',
            'code': 'code',
            'redirect_uri': 'redirect_uri'
        }

        self._client_id = client_id
        self._client_secret = client_secret
        self._code = code
        self._redirect_uri = redirect_uri

    @property
    def client_id(self):
        """
        Gets the client_id of this ObtainTokenRequest.
        Your application's ID, available from the [application dashboard](https://connect.squareup.com/apps).

        :return: The client_id of this ObtainTokenRequest.
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """
        Sets the client_id of this ObtainTokenRequest.
        Your application's ID, available from the [application dashboard](https://connect.squareup.com/apps).

        :param client_id: The client_id of this ObtainTokenRequest.
        :type: str
        """

        self._client_id = client_id

    @property
    def client_secret(self):
        """
        Gets the client_secret of this ObtainTokenRequest.
        Your application's secret, available from the [application dashboard](https://connect.squareup.com/apps).

        :return: The client_secret of this ObtainTokenRequest.
        :rtype: str
        """
        return self._client_secret

    @client_secret.setter
    def client_secret(self, client_secret):
        """
        Sets the client_secret of this ObtainTokenRequest.
        Your application's secret, available from the [application dashboard](https://connect.squareup.com/apps).

        :param client_secret: The client_secret of this ObtainTokenRequest.
        :type: str
        """

        self._client_secret = client_secret

    @property
    def code(self):
        """
        Gets the code of this ObtainTokenRequest.
        The authorization code to exchange.

        :return: The code of this ObtainTokenRequest.
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """
        Sets the code of this ObtainTokenRequest.
        The authorization code to exchange.

        :param code: The code of this ObtainTokenRequest.
        :type: str
        """

        self._code = code

    @property
    def redirect_uri(self):
        """
        Gets the redirect_uri of this ObtainTokenRequest.
        The redirect URL assigned in the [application dashboard](https://connect.squareup.com/apps).

        :return: The redirect_uri of this ObtainTokenRequest.
        :rtype: str
        """
        return self._redirect_uri

    @redirect_uri.setter
    def redirect_uri(self, redirect_uri):
        """
        Sets the redirect_uri of this ObtainTokenRequest.
        The redirect URL assigned in the [application dashboard](https://connect.squareup.com/apps).

        :param redirect_uri: The redirect_uri of this ObtainTokenRequest.
        :type: str
        """

        self._redirect_uri = redirect_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
