# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class RevokeTokenRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, client_id=None, access_token=None, merchant_id=None):
        """
        RevokeTokenRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'client_id': 'str',
            'access_token': 'str',
            'merchant_id': 'str'
        }

        self.attribute_map = {
            'client_id': 'client_id',
            'access_token': 'access_token',
            'merchant_id': 'merchant_id'
        }

        self._client_id = client_id
        self._access_token = access_token
        self._merchant_id = merchant_id

    @property
    def client_id(self):
        """
        Gets the client_id of this RevokeTokenRequest.
        Your application's ID, available from the [application dashboard](https://connect.squareup.com/apps).

        :return: The client_id of this RevokeTokenRequest.
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """
        Sets the client_id of this RevokeTokenRequest.
        Your application's ID, available from the [application dashboard](https://connect.squareup.com/apps).

        :param client_id: The client_id of this RevokeTokenRequest.
        :type: str
        """

        self._client_id = client_id

    @property
    def access_token(self):
        """
        Gets the access_token of this RevokeTokenRequest.
        The access token of the merchant whose token you want to revoke. Do not provide a value for merchant_id if you provide this parameter.

        :return: The access_token of this RevokeTokenRequest.
        :rtype: str
        """
        return self._access_token

    @access_token.setter
    def access_token(self, access_token):
        """
        Sets the access_token of this RevokeTokenRequest.
        The access token of the merchant whose token you want to revoke. Do not provide a value for merchant_id if you provide this parameter.

        :param access_token: The access_token of this RevokeTokenRequest.
        :type: str
        """

        self._access_token = access_token

    @property
    def merchant_id(self):
        """
        Gets the merchant_id of this RevokeTokenRequest.
        The ID of the merchant whose token you want to revoke. Do not provide a value for access_token if you provide this parameter.

        :return: The merchant_id of this RevokeTokenRequest.
        :rtype: str
        """
        return self._merchant_id

    @merchant_id.setter
    def merchant_id(self, merchant_id):
        """
        Sets the merchant_id of this RevokeTokenRequest.
        The ID of the merchant whose token you want to revoke. Do not provide a value for access_token if you provide this parameter.

        :param merchant_id: The merchant_id of this RevokeTokenRequest.
        :type: str
        """

        self._merchant_id = merchant_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
