# coding: utf-8

"""
Copyright 2017 Square, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re


class V1PaymentTax(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, errors=None, name=None, applied_money=None, rate=None, inclusion_type=None, fee_id=None):
        """
        V1PaymentTax - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'errors': 'list[Error]',
            'name': 'str',
            'applied_money': 'V1Money',
            'rate': 'str',
            'inclusion_type': 'str',
            'fee_id': 'str'
        }

        self.attribute_map = {
            'errors': 'errors',
            'name': 'name',
            'applied_money': 'applied_money',
            'rate': 'rate',
            'inclusion_type': 'inclusion_type',
            'fee_id': 'fee_id'
        }

        self._errors = errors
        self._name = name
        self._applied_money = applied_money
        self._rate = rate
        self._inclusion_type = inclusion_type
        self._fee_id = fee_id

    @property
    def errors(self):
        """
        Gets the errors of this V1PaymentTax.
        Any errors that occurred during the request.

        :return: The errors of this V1PaymentTax.
        :rtype: list[Error]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """
        Sets the errors of this V1PaymentTax.
        Any errors that occurred during the request.

        :param errors: The errors of this V1PaymentTax.
        :type: list[Error]
        """

        self._errors = errors

    @property
    def name(self):
        """
        Gets the name of this V1PaymentTax.
        The merchant-defined name of the tax.

        :return: The name of this V1PaymentTax.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this V1PaymentTax.
        The merchant-defined name of the tax.

        :param name: The name of this V1PaymentTax.
        :type: str
        """

        self._name = name

    @property
    def applied_money(self):
        """
        Gets the applied_money of this V1PaymentTax.
        The amount of money that this tax adds to the payment.

        :return: The applied_money of this V1PaymentTax.
        :rtype: V1Money
        """
        return self._applied_money

    @applied_money.setter
    def applied_money(self, applied_money):
        """
        Sets the applied_money of this V1PaymentTax.
        The amount of money that this tax adds to the payment.

        :param applied_money: The applied_money of this V1PaymentTax.
        :type: V1Money
        """

        self._applied_money = applied_money

    @property
    def rate(self):
        """
        Gets the rate of this V1PaymentTax.
        The rate of the tax, as a string representation of a decimal number. A value of 0.07 corresponds to a rate of 7%.

        :return: The rate of this V1PaymentTax.
        :rtype: str
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """
        Sets the rate of this V1PaymentTax.
        The rate of the tax, as a string representation of a decimal number. A value of 0.07 corresponds to a rate of 7%.

        :param rate: The rate of this V1PaymentTax.
        :type: str
        """

        self._rate = rate

    @property
    def inclusion_type(self):
        """
        Gets the inclusion_type of this V1PaymentTax.
        Whether the tax is an ADDITIVE tax or an INCLUSIVE tax.

        :return: The inclusion_type of this V1PaymentTax.
        :rtype: str
        """
        return self._inclusion_type

    @inclusion_type.setter
    def inclusion_type(self, inclusion_type):
        """
        Sets the inclusion_type of this V1PaymentTax.
        Whether the tax is an ADDITIVE tax or an INCLUSIVE tax.

        :param inclusion_type: The inclusion_type of this V1PaymentTax.
        :type: str
        """

        self._inclusion_type = inclusion_type

    @property
    def fee_id(self):
        """
        Gets the fee_id of this V1PaymentTax.
        The ID of the tax, if available. Taxes applied in older versions of Square Register might not have an ID.

        :return: The fee_id of this V1PaymentTax.
        :rtype: str
        """
        return self._fee_id

    @fee_id.setter
    def fee_id(self, fee_id):
        """
        Sets the fee_id of this V1PaymentTax.
        The ID of the tax, if available. Taxes applied in older versions of Square Register might not have an ID.

        :param fee_id: The fee_id of this V1PaymentTax.
        :type: str
        """

        self._fee_id = fee_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
